/* -*- c-file-style: "ruby"; indent-tabs-mode: nil -*- */

#include "rb-papi.h"

void
rb_papi_status_check(papi_status_t status)
{
    if (status != PAPI_OK) {
        rb_raise(rb_papi_corresponding_error(status),
                 "%s", papiStatusString(status));
    }
}

static VALUE
rb_papi_status_string(VALUE self, VALUE status)
{
    return rb_str_new2(papiStatusString(NUM2INT(status)));
}

void
Init_rb_papi_status(VALUE mPAPI)
{
    VALUE mStatus;
    mStatus = rb_define_module_under(mPAPI, "Status");

    rb_define_module_function(mStatus, "string", rb_papi_status_string, 1);

    rb_define_const(mStatus, "OK", INT2NUM(PAPI_OK));
    rb_define_const(mStatus, "OK_SUBST", INT2NUM(PAPI_OK_SUBST));
    rb_define_const(mStatus, "OK_CONFLICT", INT2NUM(PAPI_OK_CONFLICT));
    rb_define_const(mStatus, "OK_IGNORED_SUBSCRIPTIONS",
                    INT2NUM(PAPI_OK_IGNORED_SUBSCRIPTIONS));
    rb_define_const(mStatus, "OK_IGNORED_NOTIFICATIONS",
                    INT2NUM(PAPI_OK_IGNORED_NOTIFICATIONS));
    rb_define_const(mStatus, "OK_TOO_MANY_EVENTS",
                    INT2NUM(PAPI_OK_TOO_MANY_EVENTS));
    rb_define_const(mStatus, "OK_BUT_CANCEL_SUBSCRIPTION",
                    INT2NUM(PAPI_OK_BUT_CANCEL_SUBSCRIPTION));
    rb_define_const(mStatus, "REDIRECTION_OTHER_SITE",
                    INT2NUM(PAPI_REDIRECTION_OTHER_SITE));
    rb_define_const(mStatus, "BAD_REQUEST", INT2NUM(PAPI_BAD_REQUEST));
    rb_define_const(mStatus, "FORBIDDEN", INT2NUM(PAPI_FORBIDDEN));
    rb_define_const(mStatus, "NOT_AUTHENTICATED",
                    INT2NUM(PAPI_NOT_AUTHENTICATED));
    rb_define_const(mStatus, "NOT_AUTHORIZED", INT2NUM(PAPI_NOT_AUTHORIZED));
    rb_define_const(mStatus, "NOT_POSSIBLE", INT2NUM(PAPI_NOT_POSSIBLE));
    rb_define_const(mStatus, "TIMEOUT", INT2NUM(PAPI_TIMEOUT));
    rb_define_const(mStatus, "NOT_FOUND", INT2NUM(PAPI_NOT_FOUND));
    rb_define_const(mStatus, "GONE", INT2NUM(PAPI_GONE));
    rb_define_const(mStatus, "REQUEST_ENTITY", INT2NUM(PAPI_REQUEST_ENTITY));
    rb_define_const(mStatus, "REQUEST_VALUE", INT2NUM(PAPI_REQUEST_VALUE));
    rb_define_const(mStatus, "DOCUMENT_FORMAT", INT2NUM(PAPI_DOCUMENT_FORMAT));
    rb_define_const(mStatus, "ATTRIBUTES", INT2NUM(PAPI_ATTRIBUTES));
    rb_define_const(mStatus, "URI_SCHEME", INT2NUM(PAPI_URI_SCHEME));
    rb_define_const(mStatus, "CHARSET", INT2NUM(PAPI_CHARSET));
    rb_define_const(mStatus, "CONFLICT", INT2NUM(PAPI_CONFLICT));
    rb_define_const(mStatus, "COMPRESSION_NOT_SUPPORTED",
                    INT2NUM(PAPI_COMPRESSION_NOT_SUPPORTED));
    rb_define_const(mStatus, "COMPRESSION_ERROR",
                    INT2NUM(PAPI_COMPRESSION_ERROR));
    rb_define_const(mStatus, "DOCUMENT_FORMAT_ERROR",
                    INT2NUM(PAPI_DOCUMENT_FORMAT_ERROR));
    rb_define_const(mStatus, "DOCUMENT_ACCESS_ERROR",
                    INT2NUM(PAPI_DOCUMENT_ACCESS_ERROR));
    rb_define_const(mStatus, "ATTRIBUTES_NOT_SETTABLE",
                    INT2NUM(PAPI_ATTRIBUTES_NOT_SETTABLE));
    rb_define_const(mStatus, "IGNORED_ALL_SUBSCRIPTIONS",
                    INT2NUM(PAPI_IGNORED_ALL_SUBSCRIPTIONS));
    rb_define_const(mStatus, "TOO_MANY_SUBSCRIPTIONS",
                    INT2NUM(PAPI_TOO_MANY_SUBSCRIPTIONS));
    rb_define_const(mStatus, "IGNORED_ALL_NOTIFICATIONS",
                    INT2NUM(PAPI_IGNORED_ALL_NOTIFICATIONS));
    rb_define_const(mStatus, "PRINT_SUPPORT_FILE_NOT_FOUND",
                    INT2NUM(PAPI_PRINT_SUPPORT_FILE_NOT_FOUND));
    rb_define_const(mStatus, "INTERNAL_ERROR", INT2NUM(PAPI_INTERNAL_ERROR));
    rb_define_const(mStatus, "OPERATION_NOT_SUPPORTED",
                    INT2NUM(PAPI_OPERATION_NOT_SUPPORTED));
    rb_define_const(mStatus, "SERVICE_UNAVAILABLE",
                    INT2NUM(PAPI_SERVICE_UNAVAILABLE));
    rb_define_const(mStatus, "VERSION_NOT_SUPPORTED",
                    INT2NUM(PAPI_VERSION_NOT_SUPPORTED));
    rb_define_const(mStatus, "DEVICE_ERROR", INT2NUM(PAPI_DEVICE_ERROR));
    rb_define_const(mStatus, "TEMPORARY_ERROR", INT2NUM(PAPI_TEMPORARY_ERROR));
    rb_define_const(mStatus, "NOT_ACCEPTING", INT2NUM(PAPI_NOT_ACCEPTING));
    rb_define_const(mStatus, "PRINTER_BUSY", INT2NUM(PAPI_PRINTER_BUSY));
    rb_define_const(mStatus, "ERROR_JOB_CANCELLED",
                    INT2NUM(PAPI_ERROR_JOB_CANCELLED));
    rb_define_const(mStatus, "MULTIPLE_JOBS_NOT_SUPPORTED",
                    INT2NUM(PAPI_MULTIPLE_JOBS_NOT_SUPPORTED));
    rb_define_const(mStatus, "PRINTER_IS_DEACTIVATED",
                    INT2NUM(PAPI_PRINTER_IS_DEACTIVATED));
    rb_define_const(mStatus, "BAD_ARGUMENT", INT2NUM(PAPI_BAD_ARGUMENT));
    rb_define_const(mStatus, "JOB_TICKET_NOT_SUPPORTED",
                    INT2NUM(PAPI_JOB_TICKET_NOT_SUPPORTED));
}
