/* -*- c-file-style: "ruby"; indent-tabs-mode: nil -*- */

#ifndef RB_PAPI_H
#define RB_PAPI_H

#include <ruby.h>

#include "papi.h"

#ifndef TRUE
#  define TRUE 1
#endif
#ifndef FALSE
#  define FALSE 0
#endif

#define BUFFER_SIZE 4096

#define RVAL2MD(obj)              (rb_papi_r2c_metadata(obj))
#define MD2RVAL(obj)              (rb_papi_c2r_metadata(obj))
#define RVAL2ATTR(obj)            ((papi_attribute_t *)(RDATA(obj)->data))
#define ATTR2RVAL_NO_FREE(obj)    (rb_papi_c2r_attribute_no_free(obj))
#define RVAL2FILTER(obj)          ((papi_filter_t *)(RDATA(obj)->data))
#define FILTER2RVAL(obj)          (rb_papi_c2r_filter(obj))
#define RVAL2SERVICE(obj)         ((papi_service_t)(RDATA(obj)->data))
#define SERVICE2RVAL_NO_FREE(obj) (rb_papi_c2r_service_no_free(obj))
#define RVAL2PRINTER(obj)         ((papi_printer_t)(RDATA(obj)->data))
#define PRINTER2RVAL(obj)         (rb_papi_c2r_printer(obj))
#define PRINTER2RVAL_NO_FREE(obj) (rb_papi_c2r_printer_no_free(obj))
#define RVAL2ATTRLST(obj)         ((papi_attribute_t **)(RDATA(obj)->data))
#define ATTRLST2RVAL(obj)         (rb_papi_c2r_attribute_list(obj))
#define ATTRLST2RVAL_NO_FREE(obj) (rb_papi_c2r_attribute_list_no_free(obj))
#define RVAL2JOB(obj)             ((papi_job_t)(RDATA(obj)->data))
#define JOB2RVAL(obj)             (rb_papi_c2r_job(obj))
#define JOB2RVAL_NO_FREE(obj)     (rb_papi_c2r_job_no_free(obj))
#define RVAL2JT(obj)              ((papi_job_ticket_t *)(RDATA(obj)->data))
#define JT2RVAL_NO_FREE(obj)      (rb_papi_c2r_job_ticket_no_free(obj))
#define RVAL2JS(obj)              ((papi_job_ticket_t *)(RDATA(obj)->data))
#define JS2RVAL_NO_FREE(obj)      (rb_papi_c2r_job_stream_no_free(obj))

typedef VALUE (*c2r_attr_value_t) (papi_attribute_value_t *value);

extern void Init_rb_papi_error(VALUE mPAPI);
extern void Init_rb_papi_encrypt(VALUE mPAPI);
extern void Init_rb_papi_resolution(VALUE mPAPI);
extern void Init_rb_papi_metadata(VALUE mPAPI);
extern void Init_rb_papi_attribute(VALUE mPAPI);
extern void Init_rb_papi_status(VALUE mPAPI);
extern void Init_rb_papi_job(VALUE mPAPI);
extern void Init_rb_papi_filter(VALUE mPAPI);
extern void Init_rb_papi_service(VALUE mPAPI);
extern void Init_rb_papi_printer(VALUE mPAPI);
extern void Init_rb_papi_attribute_list(VALUE mPAPI);

extern VALUE rb_papi_c2r_metadata(papi_metadata_t data);
extern VALUE rb_papi_c2r_attribute_no_free(papi_attribute_t *attr);
extern VALUE rb_papi_c2r_attribute_list(papi_attribute_t **attrs);
extern VALUE rb_papi_c2r_attribute_list_no_free(papi_attribute_t **attrs);
extern VALUE rb_papi_c2r_job(papi_job_t job);
extern VALUE rb_papi_c2r_job_no_free(papi_job_t job);
extern VALUE rb_papi_c2r_job_stream_no_free(papi_stream_t stream);

extern papi_attribute_t *rb_papi_r2c_attribute(VALUE name, VALUE rb_value);
extern papi_metadata_t rb_papi_r2c_metadata(VALUE data);

extern void rb_papi_status_check(papi_status_t status);
extern VALUE rb_papi_corresponding_error(papi_status_t status);

#define ARY2STRARY(array, strary) do {                          \
    if (NIL_P(array)) {                                         \
        strary = ALLOCA_N(char *, 1);                           \
        *strary = NULL;                                         \
    } else {                                                    \
        char **attr;                                            \
        int i, len;                                             \
                                                                \
        len = RARRAY(array)->len;                               \
        strary = ALLOCA_N(char *, len + 1);                     \
        for (i = 0; i < len; i++) {                             \
            attr = strary + i;                                  \
            *attr = StringValueCStr(RARRAY(array)->ptr[i]);     \
        }                                                       \
        attr = strary + i;                                      \
        *attr = NULL;                                           \
    }                                                           \
} while (0)

#endif
